Subject: Re: bug#59194: 29.0.50; Tramp autoloads and ordering

From: Stefan Monnier <[email-masked]>
Date: Fri, 18 Nov 2022 16:16:33 -0500

>> `tramp.el` has the following:
>>
>>     ;;;###tramp-autoload
>>     (progn
>>       (defvar tramp--startup-hook nil
>>         "Forms to be executed at the end of tramp.el.")
>>       (put 'tramp--startup-hook 'tramp-suppress-trace t)
>>
>>       (defmacro tramp--with-startup (&rest body)
>>         "Schedule BODY to be executed at the end of tramp.el."
>>         `(add-hook 'tramp--startup-hook (lambda () ,@body))))
>>
>> and then various other Tramp files have autoloaded forms like:
>>
>>     ;;;###tramp-autoload
>>     (tramp--with-startup
>>      (add-to-list 'tramp-methods
>>       ...))
>>
>> The problem here is that the resulting `tramp-loaddefs.el` may or may
>> not be valid depending on the order in which it gets filled, which is
>> not something that's documented/guaranteed.
>
> I'm aware of this. It was already reported on emacs-devel, see thread
> starting with <[email-masked]>. In that case I've added
> some variable declarations.
>
> However, I don't know how to fix this in general.

Can you arrange to load `tramp-loaddefs.el` only after some
initialization (e.g. creation of `tramp-foo-methods` or equivalent) so
you can do just:

    ;;;###tramp-autoload
    (add-to-list 'tramp-foo-methods ...)

If those methods really need to be registered later, then `tramp.el` can
finish with a short loop moving the methods from `tramp-foo-methods` to
`tramp-methods`.

Would that make sense?

        Stefan